1 Introduction
The shortest path network interdiction problem (1SPNI) usually involves two parties competing against each other. One player tries to compute its shortest path from source to sink, while the second player, called the interdictor, who is subject to a restricted interdiction budget, removes arcs from the network to maximally deteriorate the first players shortest path length.
One of the earliest works representing a special case of (1SPNI), called the most vital arcs problem, in which the interdiction of an arc requires exactly one unit of the interdictors budget, has been studied by the authors in Malik et al. (1989). The most vital arcs problem as well as (1SPNI) have been shown to be hard, cf. BarNoy et al. (1998); Ball et al. (1989). In Corley & David (1982), the most vital arcs problem is analyzed and related to the shortest path problem. The authors also provide an algorithm to obtain a most vital link, which is again a special case of the most vital arcs problem for equals . Instead of removing arcs, Fulkerson & Harding (1977) and Golden (1978) study related problems, where each arc is associated with an interdiction cost per unit to increase the effective length of that arc. Another variant is studied in Khachiyan et al. (2008), where each vertex is associated with a number denoting how many outgoing arcs might be deleted. An extension of Dijkstra’s algorithm efficiently solving the problem is provided along with inapproximability bounds for the most vital arcs problem and various related problems. This variant is in turn altered in Andersson (2009) to solve a shortest path interdiction problem with nodewise budget, where partial interdiction is allowed. Additionally, a shortest path interdiction problem with nodewise budget and a bottleneck objective is considered along with an algorithmic idea for the shortest path interdiction problem with bottleneck objective, a global budget and unit interdiction costs. In one of the most prominent works dealing with (1SPNI) in its most general form, cf. Israeli & Wood (2002), two algorithms with different quality, depending on whether interdicted arcs are removed or if an interdicted arc’s length is increased by some value, are provided.
However, literature on biobjective extensions and variants of (1SPNI) is rather sparse. In RamirezMarquez et al. (2010), a biobjective variant considering the maximization of the shortest path length and the minimization of interdiction costs is investigated. Finding an optimal route for an ambulance is considered in Torchiani et al. (2017). The problem is modelled as a biobjective problem where the first objective seeks to minimize the shortest path from source to sink while the second objective minimizes the maximal length of a detour in case the chosen route is blocked.
Our contribution
To the best of our knowledge, we provide the first extension of (1SPNI) involving an additional player, called (2SPNI): Each arc in the network is associated with two integer lengths and both the first and the second player aim to compute their respective shortest path from source to sink. The interdictor’s task is to remove arcs from the network while satisfying a given interdiction budget to maximize both the first and the second players objective. We formally introduce the problem in Section 2 and prove that the number of nondominated points might be exponential in the number of vertices of the network, see Section 3. Additionally, we show that deciding whether a feasible interdiction strategy is efficient or not, is complete. In Sections 4 and 5, we discuss solution methods for (2SPNI) with sum and bottleneck objectives, respectively. More specifically, we discuss a pseudopolynomial time dynamic programming algorithm on twoterminal seriesparallel graphs for the case of (2SPNI) with sum objectives and provide a polynomial time algorithm on general directed graphs for a variant of the problem with bottleneck objectives. Section 6 summarizes the article and provides further directions of research.
2 Preliminaries and problem formulation
Let be a directed network with vertex set and arc set with and . If the network is not clear from the context, we write and to refer to the set of vertices and arcs of , respectively. Let be the source and sink vertex in , respectively. Each arc in is associated with two integer length values, i.e., with for . The maximum arc length is denoted by and for player one and two, respectively, i.e., . By , we denote the maximum of and . Note that two possibly different shortest paths and might be computed in with respect to and , respectively. By , we denote the set of all paths in and we compute the length of a path with respect to as the sum of all arc lengths in , i.e., , where denotes the set of arcs in . Further, interdicting arc is associated with a cost and denotes the given interdiction budget. Thus, by we refer to the set of all feasible interdiction strategies, i.e.,
where the binary variable
equals one if arc is interdicted and zero otherwise. Consequently, each feasible interdiction strategy induces an interdicted graph with and , where .We interpret this setting as a game composed of three players. Whereas player one and two compute their respective shortest paths independently from each other in for some , the interdictor aims to maximize both shortest path lengths simultaneously by fixing some interdiction strategy . Thus, each interdiction strategy yields a tuple of shortest path lengths in , i.e.,
To compare vectors of shortest path lengths, we use the standard Paretoorder in
, cf. Ehrgott (2005), which is defined as follows:where and . Since does not define a total order on the objective function values in , one aims to find the feasible interdiction strategies that do not allow to improve the objective of the first shortest path player without deteriorating the second player’s objective. Thus, (2SPNI) can be stated as .
Definition 2.1.
A feasible interdiction strategy is called efficient, if there does not exist such that
In this case, we call a nondominated point. With , we denote the set of efficient interdiction strategies. The set of all nondominated points is denoted by .
A special emphasis is put on twoterminal seriesparallel graphs, which are defined as follows, cf. Eppstein (1992).
Definition 2.2.
A directed network is called twoterminal seriesparallel with source and sink , if can be constructed by a sequence of the following operations.

Construct a primitive graph with and .

(Parallel Composition) Given two directed, seriesparallel graphs with source and sink and with source and sink , form a new graph by identifying and .

(Series Composition) Given two directed, seriesparallel graphs with source and sink and with source and sink , form a new graph by identifying , and .
A twoterminal seriesparallel graph can be recognized in polynomial time along with the corresponding decomposition tree . Further, the size of is linear in the size of and can be computed in linear time, cf. Valdes et al. (1982). The decomposition tree specifies how has been constructed using the rules mentioned in Definition 2.2. In the following, we assume that each vertex in is associated with a twoterminal seriesparallel graph, for an example see Figure 1.
In the following, denotes an instance of (2SPNI), where is a directed network, denotes a length function assigning two lengths to each arc, assigns every arc an interdiction cost and refers to the interdiction budget.
3 Complexity
In this section, we investigate the complexity and tractability of (2SPNI). Therefore, we consider the following decision version of (2SPNI), which asks whether a given interdiction strategy is efficient or not: Given an instance of (2SPNI) and a value , decide whether there exists an interdiction strategy with .
Theorem 3.1.
The decision version of (2SPNI) is complete, even on twoterminal seriesparallel graphs.
Proof.
Follows immediately from the fact that the decision version of (1SPNI) is complete on twoterminal seriesparallel graphs, cf. Ball et al. (1989). Although the reduction proof presented by the authors does not use a twoterminal seriesparallel graph, it can be easily modified such that completeness also holds for twoterminal seriesparallel graphs. ∎
Further, in the field of multiobjective optimization one is usually interested in the (in)tractability of a specific problem, i.e., to investigate whether there exists a problem instance with an exponential number of nondominated points with respect to the size of that instance.
Theorem 3.2.
The problem (2SPNI) is intractable, even on twoterminal seriesparallel graphs and even for unit interdiction costs, i.e., the number of nondominated points might be exponential in the size of the problem instance.
Proof.
To prove intractability of (2SPNI), we construct an instance, where the number of nondominated points is exponential in the number of vertices. Therefore, let be an instance of (2SPNI) with for all and vertices, i.e., with
being odd. There are two types of arcs going from
to for all , denoted by and , respectively, with and . We create copies of the latter type of arcs for all such that the resulting network has arcs. Further, we set . Note that due to construction there does not exist a such that we can separate from . Further, one can see that all with cannot be efficient and that it is always beneficial to interdict arcs of type instead of .Therefore, we only consider those interdiction strategies with and equals for all with . We denote the set by . It holds for the shortest path length of the first player that:
Note that the lower and upper bound are attained by removing the first and last arcs of type , respectively. Further, for every , it holds that . Additionally, for all with . Thus, each induces a different nondominated point. Since and using Stirling’s formula, we showed that the number of nondominated points is exponential in , which concludes the proof. ∎
4 Solution method for twoterminal seriesparallel graphs
We state a dynamic programming algorithm with a pseudopolynomial running time for the case of twoterminal seriesparallel graphs. Throughout this section, we assume that a twoterminal seriesparallel graph is accompanied by its decomposition tree . We derive a dynamic programming algorithm starting at the leaves of and iterating bottom up through the decomposition tree. In the course of the algorithm, we create labels of the form with and being a graph in . By , we denote the set of all labels correponding to nondominated points in the graph with a total interdiction cost of . We aim to find the set of all nondominated points for all graphs in and for all .
If is a primitive graph, i.e., a leaf of , with and , we can clearly calculate in case of for all , in the following way:
(1) 
If , then is equal to for all .
For being the series or parallel composition of and , we define the following two operations.
Definition 4.1.
Let be two sets. Then,

Minkowski sum

, where with and
If is the parallel composition of and , we calculate as follows:
(2) 
Thus, we combine each nondominated point with each nondominated point in for all by taking the respective minimum in each component. By , we denote that all dominated points with respect to the Paretoorder get discarded afterwards.
If is the series composition of and , we calculate as follows:
(3) 
In this case, nondominated points are combined by summing them up. Again, dominated points get discarded afterwards.
Theorem 4.2.
Proof.
We use induction on the size of the decomposition tree of . Let be a graph in . If is a primitive graph, i.e., a leaf vertex of , the set of nondominated points can clearly be computed by using (1). Now, let be the series composition of and . For the sake of contradiction, suppose is a nondominated point in for some and that has not been found. Let , where and with . Let . If and , then would have been created at due to construction of the algorithm. Thus, we assume that or . Without loss of generality, we assume that . It follows that there exists a nondominated point with . Consequently, it holds that , which is a contradiction to our assumption that is nondominated. The claim can analogously be proven for the case of being the parallel composition of and . ∎
Further, the above described dynamic programming algorithm runs in pseudopolynomial time.
Theorem 4.3.
The dynamic programming algorithm has a worstcase runningtime complexity of .
Proof.
The decomposition tree has leaf vertices. Since it is a binary tree, we know that has vertices. Each leaf requires constant time for determining one label set. For each leaf we construct labels. Let be a subgraph of corresponding to one of the nonleaves in . We call and the subgraphs of corresponding to the children of in the decomposition tree. Every path in , independent of the interdiction strategy, can be of length between and or for both players. Thus, the number of nondominated labels in is in for all . For each of the nonleaves we require two steps. First, we create labels. Second, we have to check the labels for nondominance, which can be done in , cf. Kung et al. (1975). Executing these operations at most times, yields an overall running time complexity of , which is pseudopolynomial in the size of the input. ∎
5 A variant with bottleneck objectives
In this section, we modify the objective function of both players by introducing the bottleneck objective. Thus, the value of a path is equal to its largest arc length, i.e., , . Again, each interdiction strategy induces a tuple of bottleneck shortest path lengths in , i.e.,
Similar, to (2SPNI) with sum objectives, we aim to find those interdiction strategies that do not allow to improve the bottleneck objective of the first player without worsening the second player’s bottleneck objective. Consequently, (2SPNI) with bottleneck objectives can be stated as .
In Andersson (2009), the author states an idea how to solve this problem for the case of one player and unit interdiction costs. We extend the idea and show how to solve it for two players and general interdiction costs in polynomial time. For this purpose, we define an cut to be a partition of the vertices of into two nonempty subsets, i.e., , with and and . The cut set is defined as and the value of as . The minimal cut in , denoted by , is an cut with minimal value over all possible cuts with respect to the interdiction costs. Further, denotes the subgraph of with and for some .
Lemma 5.1.
Let be a network and . If the value of a minimal cut in is at most the interdiction budget , i.e., , then there exists an interdiction strategy with and .
Proof.
Let be an cut in with . Define with equals if and otherwise. Consequently, each path has to use at least one arc from the set , yielding and . ∎
Lemma 5.2.
Let be a network and . If the value of a minimal cut in is greater than the interdiction budget , i.e., , then it holds that or for all .
Proof.
We prove the claim by contraposition. Therefore, let be an interdiction strategy with and .
Claim 1: The interdiction strategy separates from in and .
Proof of Claim 1: For the sake of contradiction assume that there is a path . It follows that and thus, , contradicting our assumption. Following the same argumentation, separates from in .
Claim 2: The interdiction strategy separates from in .
Proof of Claim 2: Let with and . It follows:
By the proof of claim 1, it follows that separates from in and thus, , which concludes the proof. ∎
Thus, we proved the following equivalence.
Corollary 5.3.
Let be a network and . The value of a minimal cut in is greater than the interdiction budget , i.e., , if and only if or for all .
Using this equivalence, we state an algorithm that returns all nondominated points of an instance of (2SPNI) with bottleneck objectives.
The idea of the algorithm is to efficiently iterate through various subgraphs and determine a minimal cut with respect to the interdiction costs. Depending on the result, we reduce or extend the subgraph. All interdiction strategies corresponding to the cut set arcs of minimal cuts with a value smaller than are stored in . These correspond to feasible interdiction strategies. Before we return the corresponding points induced by those strategies, they are checked for nondominance.
Theorem 5.4.
Algorithm 1 terminates after finitely many steps and returns all nondominated points.
Proof.
During each iteration of the while loop, we either decrease the value of or we exit the while loop. Further, note that there are at most entries in and , respectively. Consequently, the algorithm terminates after finitely many steps. Let be a nondominated point for some . We need to distinguish two cases, i.e., and . First, assume that . We know that and by definition of the bottleneck objective. Consider iteration . At the beginning of iteration , has some value . We distinguish three cases.
Case 1: If , we consider . By Lemma 5.1 and since is a nondominated point, it follows that . As a consequence, is reduced during the course of the while loop until . We compute and follow along the lines of Case 2.
Case 2: If , we use Lemma 5.2. Since is a nondominated point, we can conclude that . In this case, we find a strategy with the given objective, save the corresponding nondominated point, and continue with the next iteration, i.e., investigating the next entry in without decreasing .
Case 3: . Due to construction of the algorithm, we know that only decreases. Thus, there was an earlier iteration , when was reduced to some value smaller than . Therefore, we must have investigated the subgraph . It follows that . Otherwise, would not have been reduced to some value smaller than . By Lemma 5.2, it follows that or for all . This is a contradiction, since equals and neither holds, nor . It follows that Case 3 can not occur.
Now, assume that . Therefore, the point is saved in . Consequently, is optimal in all objectives and no further strategies need to be found. Due to line 18, no points are returned that are not nondominated. The algorithm only finds feasible interdiction strategies. Thus, no nondominated points are discarded in line 18. ∎
Theorem 5.5.
Algorithm 1 runs in polynomial time, i.e., in , where and denote the time for solving a minimum cut and a bottleneck shortest path problem, respectively.
Proof.
The initialization of and is in . We consider the inner body of the while loop. In each iteration, we either break the while loop (so we increase ) or we decrease . That leaves us with at most iterations. In each iteration, a subgraph of gets computed in , a minimal cut is determined in and potentially two bottleneck shortest path problems have to be computed, which is in . As proposed in Kung et al. (1975), checking at most entries of for nondominance requires computation steps. That results in a worst case running time of
which concludes the proof. ∎
Remark 5.6.
Note that both a minimum cut problem as well as a bottleneck shortest path problem can be solved in polynomial time, cf. Kaibel & Peinhardt (2006).
6 Conclusion
In this article, we provided a biobjective extension of the shortest path network interdiction problem resulting in a game composed of three players, i.e., two shortest path players and one interdictor. We considered the cases of two shortest path players with sum and bottleneck objectives, respectively. The problem’s complexity was investigated for twoterminal seriesparallel graphs and general directed graphs. The discussed decision version of the two player shortest path network interdiction problem with sum objectives was shown to be complete, even for twoterminal seriesparallel graphs. Further, we provided an instance with an exponential number of nondominated points proving the problem to be intractable, even for unit interdiction costs and on twoterminal seriesparallel graphs. Despite the hardness of the two player shortest path network interdiction problem with sum objectives, we derived an algorithm that solves the respective problem with bottleneck objectives on general directed graphs in polynomial time.
The two player shortest path network interdiction problem is open to a wide range of further research, including potential approximation and/or pseudoapproximation approaches. The development of algorithms for more general graph classes in case of sum objectives provides further interesting fields of study.
Acknowledgments
This work was partially supported by the Bundesministerium für Bildung und Forschung (BMBF) under Grant No. 13N14561 and Deutscher Akademischer Austauschdienst (DAAD) under Grant No. 57518713.
References
References
 Andersson (2009) Andersson, D. (2009). PerfectInformation Games with Cycles. Ph.D. thesis Aarhus Universitetsforlag.
 Ball et al. (1989) Ball, M. O., Golden, B. L., & Vohra, R. V. (1989). Finding the most vital arcs in a network. Operations Research Letters, 8, 73–76.
 BarNoy et al. (1998) BarNoy, A., Khuller, S., & Schieber, B. (1998). The complexity of finding most vital arcs and nodes. Technical Report.
 Corley & David (1982) Corley, H., & David, Y. S. (1982). Most vital links and nodes in weighted networks. Operations Research Letters, 1, 157–160.
 Ehrgott (2005) Ehrgott, M. (2005). Multicriteria optimization. (2nd ed.). SpringerVerlag, Berlin, Heidelberg.
 Eppstein (1992) Eppstein, D. (1992). Parallel recognition of seriesparallel graphs. Information and Computation, 98, 41–55.
 Fulkerson & Harding (1977) Fulkerson, D. R., & Harding, G. C. (1977). Maximizing the minimum sourcesink path subject to a budget constraint. Mathematical Programming, 13, 116–118.
 Golden (1978) Golden, B. (1978). A problem in network interdiction. Naval Research Logistics Quarterly, 25, 711–713.
 Israeli & Wood (2002) Israeli, E., & Wood, R. K. (2002). Shortestpath network interdiction. Networks: An International Journal, 40, 97–111.
 Kaibel & Peinhardt (2006) Kaibel, V., & Peinhardt, M. A. (2006). On the Bottleneck Shortest Path Problem. Technical Report KonradZuse Zentrum für Informationstechnik Berlin.
 Khachiyan et al. (2008) Khachiyan, L., Boros, E., Borys, K., Elbassioni, K., Gurvich, V., Rudolf, G., & Zhao, J. (2008). On short paths interdiction problems: Total and nodewise limited interdiction. Theory of Computing Systems, 43, 204–233.
 Kung et al. (1975) Kung, H.T., Luccio, F., & Preparata, F. P. (1975). On finding the maxima of a set of vectors. Journal of the ACM (JACM), 22, 469–476.
 Malik et al. (1989) Malik, K., Mittal, A. K., & Gupta, S. K. (1989). The k most vital arcs in the shortest path problem. Operations Research Letters, 8, 223–227.
 RamirezMarquez et al. (2010) RamirezMarquez, J. E. et al. (2010). A biobjective approach for shortestpath network interdiction. Computers & Industrial Engineering, 59, 232–240.
 Torchiani et al. (2017) Torchiani, C., Ohst, J., Willems, D., & Ruzika, S. (2017). Shortest paths with shortest detours. Journal of Optimization Theory and Applications, 174, 858–874.
 Valdes et al. (1982) Valdes, J., Tarjan, R. E., & Lawler, E. L. (1982). The recognition of series parallel digraphs. SIAM Journal on Computing, 11, 298–313.
Comments
There are no comments yet.